{$A+,B-,D+,E+,F+,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 32768,0,65536}

 PROGRAM Menus_2;
 {Ca marche. Il manque juste les accessoires (raccourci)
 Dernire MAJ : 08/06/2000}

 USES CrtPlus, TObjects;

 VAR MenuFichier,MenuEdit,MenuSearch, MenuCompile, MenuRun, MenuDebug,
     MenuTools, MenuOptions, MenuWindow, MenuHelp : TMenu;
     MenuBar : TPullDownMenu;
     Ex      : BYTE;

 PROCEDURE FillMenus;
 BEGIN
      WITH MenuFichier DO BEGIN
           Init(2,30,3);
           ScrollObj:= Active;

           NewMenu('New', '', 0, NormalMenu);
           NewMenu('Open...', 'F3', 0, NormalMenu);
           NewMenu('Save', 'F2', 0, DisabledMenu);
           NewMenu('Save as...', '', 0, NormalMenu);
           NewMenu('Save all', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Change dir...', '', 0, DisabledMenu);
           NewMenu('Print', '', 0, NormalMenu);
           NewMenu('Printer setup...', '', 0, NormalMenu);
           NewMenu('Dos shell', '', 0, NormalMenu);
           NewMenu('Exit', 'ALT+X', 0, NormalMenu);
      END;

      WITH MenuEdit DO BEGIN
           Init(08,35,3);
           ScrollObj:= Active;

           NewMenu('Undo', 'ALT+BACKSPACE', 0, NormalMenu);
           NewMenu('Redo', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Cut', 'SHIFT+DEL', 0, NormalMenu);
           NewMenu('Copy', 'CTRL+INS', 0, NormalMenu);
           NewMenu('Paste', 'SHIFT+INS', 0, NormalMenu);
           NewMenu('Clear', 'CTRL+DEL', 0, DisabledMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Show clipboard', '', 0, NormalMenu);
      END;

      WITH MenuSearch DO BEGIN
           Init(14,45,03);
           ScrollObj:= Active;

           NewMenu('Find...', '', 0, NormalMenu);
           NewMenu('Replace...', '', 0, NormalMenu);
           NewMenu('Search again', '', 0, DisabledMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Go to line number...', '', 0, NormalMenu);
           NewMenu('Show last compiler error', '', 0, NormalMenu);
           NewMenu('Find error...', '', 0, DisabledMenu);
           NewMenu('Find procedure...', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Previous browser', '', 0, NormalMenu);
           NewMenu('Objects','',0,NormalMenu);
           NewMenu('Units','',0,NormalMenu);
           NewMenu('Globals','',0,NormalMenu);
           NewMenu('','',0,NormalMenu);
           NewMenu('Symbol...','',0,NormalMenu);
      END;

      WITH MenuRun DO BEGIN
           Init(22,52,3);
           ScrollObj:= Active;

           NewMenu('Run', 'CTRL+F9', 0, NormalMenu);
           NewMenu('Step over', 'F8', 0, NormalMenu);
           NewMenu('Trace into', 'F7', 0, DisabledMenu);
           NewMenu('Go to cursor', 'F4', 0, NormalMenu);
           NewMenu('Program reset', 'CTRL+F2', 0, NormalMenu);
           NewMenu('Parametres...', '', 0, NormalMenu);
      END;

      WITH MenuCompile DO BEGIN
           Init(27,50,3);
           ScrollObj:= Active;

           NewMenu('Compile', 'ALT+F9', 0, NormalMenu);
           NewMenu('Make', 'F9', 0, NormalMenu);
           NewMenu('Build', '', 0, DisabledMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Program target', '', 0, NormalMenu);
           NewMenu('Primary file...', '', 0, NormalMenu);
           NewMenu('Clear primary file', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Information...', '', 0, NormalMenu);
      END;

      WITH MenuDebug DO BEGIN
           Init(36,66,3);
           ScrollObj:= Active;

           NewMenu('Breakpoints...', '', 0, NormalMenu);
           NewMenu('Call stack', 'CTRL+F3', 0, NormalMenu);
           NewMenu('Register', '', 0, DisabledMenu);
           NewMenu('Watch', '', 0, NormalMenu);
           NewMenu('Output', '', 0, NormalMenu);
           NewMenu('User screen', 'ALT+F5', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Evaluate/Modify...', 'CTRL+F4', 0, NormalMenu);
           NewMenu('Add watch...', 'CTRL+F7', 0, NormalMenu);
           NewMenu('Add breakpoint...', '', 0, NormalMenu);
      END;

      WITH MenuTools DO BEGIN
           Init(43,70,3);
           ScrollObj:= Active;

           NewMenu('Messages', '', 0, NormalMenu);
           NewMenu('Go to next', 'ALT+F8', 0, DisabledMenu);
           NewMenu('Go to previous', 'ALT+F7', 0, DisabledMenu);
      END;

      WITH MenuOptions DO BEGIN
           Init(50,73,3);
           ScrollObj:= Active;

           NewMenu('Compiler...', '', 0, NormalMenu);
           NewMenu('Memory sizes...', '', 0, NormalMenu);
           NewMenu('Linker...', '', 0, DisabledMenu);
           NewMenu('Debugger...', 'F4', 0, NormalMenu);
           NewMenu('Directories...', '', 0, NormalMenu);
           NewMenu('Browser...', '', 0, NormalMenu);
           NewMenu('Tools...', '', 0, NormalMenu);
           NewMenu('','',0,NormalMenu);
           NewMenu('Environment', #16, 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Open...', '', 0, NormalMenu);
           NewMenu('Save', '', 0, NormalMenu);
           NewMenu('Save as...', '', 0, NormalMenu);
      END;

      WITH MenuWindow DO BEGIN
           Init(57,78,3);
           ScrollObj:= Active;

           NewMenu('Tile', '', 0, NormalMenu);
           NewMenu('Cascade', '', 0, NormalMenu);
           NewMenu('Close all', '', 0, DisabledMenu);
           NewMenu('Refresh display', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Size/move', 'CTRL+F5', 0, NormalMenu);
           NewMenu('Zoom', 'F5', 0, NormalMenu);
           NewMenu('Next', 'F6', 0, NormalMenu);
           NewMenu('Previous', 'SHIFT+F6', 0, NormalMenu);
           NewMenu('Close', 'ALT+F3', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('List...', 'ALT+0', 0, NormalMenu);
      END;

      WITH MenuHelp DO BEGIN
           Init(50,78,3);
           ScrollObj:= Active;

           NewMenu('Contents', 'ALT+F9', 0, NormalMenu);
           NewMenu('Index', 'SHIFT+F1', 0, NormalMenu);
           NewMenu('Topic search', 'CTRL+F1', 0, NormalMenu);
           NewMenu('Previous topic', 'ALT+F1', 0, NormalMenu);
           NewMenu('Using help', '', 0, NormalMenu);
           NewMenu('Files...', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('Compiler directives', '', 0, NormalMenu);
           NewMenu('Procedures and functions', '', 0, NormalMenu);
           NewMenu('Reserved words', '', 0, NormalMenu);
           NewMenu('Standard units', '', 0, NormalMenu);
           NewMenu('Borland Pascal Language', '', 0, NormalMenu);
           NewMenu('Error messages', '', 0, NormalMenu);
           NewMenu('', '', 0, NormalMenu);
           NewMenu('About...', '', 0, NormalMenu);
      END;
 END;

 PROCEDURE Presentation;
 BEGIN
      IF GetVideoMode <> 3 THEN SetTextMode(3);
      TColor(7,0); Clear; SetCursorPos(24,1); ShowCursor;
      TDrawBox(1,1,4,80, 7,0, Off, Single);
      TCenter('TMenu/TPullDownMenu OBJECTS DEMONSTRATION',2);
      TCenter('Sad LANKRI. 8 juin 2000',3);
 END;

 VAR I,J : BYTE;
 BEGIN
      Presentation;

      TColor(1,7); Clear;
      FOR I:= 2 TO 24 DO FOR J:= 1 TO 80 DO TWrite(#176,I,J);

      TColor(4,7); TMkSpace(1,80,1); TMkSpace(1,80,25);

      TCenter(TMenu/TPullDownMenu OBJECTS DEMONSTRATION  -- Sad LANKRI.  08/06/2000',25);

      FillMenus;

      WITH MenuBar DO BEGIN
           Init(1,80,1);

           NewMenu(' File ',1,NormalMenu);
           NewMenu(' Edit ',2,NormalMenu);
           NewMenu(' Search ',3,NormalMenu);
           NewMenu(' Run ',4,NormalMenu);
           NewMenu(' Compile ',5,NormalMenu);
           NewMenu(' Debug ',6,NormalMenu);
           NewMenu(' Tools ',7,NormalMenu);
           NewMenu(' Options ',8,NormalMenu);
           NewMenu(' Window ',9,NormalMenu);
           NewMenu(' Help ',10,NormalMenu);

           Run;
      END;

      Ex:= 255;

      IF MenuBar.ExitCode = ExpandSubMenu THEN
         WHILE (Ex <> Cancel) AND (Ex <> Ok) DO BEGIN

               IF Ex = Next THEN BEGIN
                  MenuBar.ItemUnselect;
                  MenuBar.NextItem;
                  MenuBar.ItemSelect;
               END;

               IF Ex = Precedent THEN BEGIN
                  MenuBar.ItemUnselect;
                  MenuBar.PreviousItem;
                  MenuBar.ItemSelect;
               END;

               CASE MenuBar.CurMenu^.Command OF
                    1 : MenuFichier.Run;
                    2 : MenuEdit.Run;
                    3 : MenuSearch.Run;
                    4 : MenuRun.Run;
                    5 : MenuCompile.Run;
                    6 : MenuDebug.Run;
                    7 : MenuTools.Run;
                    8 : MenuOptions.Run;
                    9 : MenuWindow.Run;
                   10 : MenuHelp.Run;

               END;

               CASE MenuBar.CurMenu^.Command OF
                    1 : Ex:= MenuFichier.ExitCode;
                    2 : Ex:= MenuEdit.ExitCode;
                    3 : Ex:= MenuSearch.ExitCode;
                    4 : Ex:= MenuRun.ExitCode;
                    5 : Ex:= MenuCompile.ExitCode;
                    6 : Ex:= MenuDebug.ExitCode;
                    7 : Ex:= MenuTools.ExitCode;
                    8 : Ex:= MenuOptions.ExitCode;
                    9 : Ex:= MenuWindow.ExitCode;
                   10 : Ex:= MenuHelp.ExitCode;
               END;
         END;

      MenuBar.Done; MenuFichier.Done; MenuEdit.Done; MenuSearch.Done;
      MenuRun.Done; MenuCompile.Done; MenuDebug.Done; MenuTools.Done;
      MenuOptions.Done; MenuWindow.Done; MenuHelp.Done;

      TColor(7,0); SetCursorSize(15,16); SetCursorPos(1,0); Clear;
 END.